#define TITLE "GBAHEAD GBA HEAD modify tool " __DATE__ " " __TIME__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <windows.h>

#define dbgl ;
//#define dbgl printf("%s:%d\n",__FILE__,__LINE__)


#define HEADSIZE (192)

void PrintHelp(void);

#define su8 static unsigned char
#define u8  unsigned char

/* nintendo LOGO

;------------------------------------------------------------
 	b __main

	DCB 36,255,174,81,105,154,162,33,61,132,130,10,132,228,9,173
	DCB 17,36,139,152,192,129,127,33,163,82,190,25,147,9,206,32
	DCB 16,70,74,74,248,39,49,236,88,199,232,51,130,227,206,191
	DCB 133,244,223,148,206,75,9,193,148,86,138,192,19,114,167,252
	DCB 159,132,77,115,163,202,154,97,88,151,163,39,252,3,152,118
	DCB 35,29,199,97,3,4,174,86,191,56,132,0,64,167,14,253
	DCB 255,82,254,3,111,149,48,241,151,251,192,133,96,214,128,37
	DCB 169,99,190,3,1,78,56,226,249,162,52,255,187,62,3,68
	DCB 120,0,144,203,136,17,58,148,101,192,124,99,135,240,60,175
	DCB 214,37,228,139,56,10,172,114,33,212,248,7
	DCB "PocketNES   "	;title
	DCB "PNES"		;gamecode
	DCW 0			;maker
	DCB 0x96		;fixed value
	DCB 0			;unit code
	DCB 0			;device type
	DCB 0,0,0,0,0,0,0	;unused
	DCB 0			;version
	DCB 0x6f		;complement check
	DCW 0			;unused
;----------------------------------------------------------

*/
/*
0BDh - Complement check, 1 Byte
Header checksum, cartridge won't work if incorrect. Calculate as such:
chk=0:for i=0A0h to 0BCh:chk=chk-[i]:next:chk=(chk-19h) and 0FFh

*/

#define NN (0x53)
#define nlogo_len (156)
u8 nlogo[nlogo_len]={
	 NN-36,NN-255,NN-174,NN-81,NN-105,NN-154,NN-162,NN-33,NN-61,NN-132,NN-130,NN-10,NN-132,NN-228,NN-9,NN-173,
	 NN-17,NN-36,NN-139,NN-152,NN-192,NN-129,NN-127,NN-33,NN-163,NN-82,NN-190,NN-25,NN-147,NN-9,NN-206,NN-32,
	 NN-16,NN-70,NN-74,NN-74,NN-248,NN-39,NN-49,NN-236,NN-88,NN-199,NN-232,NN-51,NN-130,NN-227,NN-206,NN-191,
	 NN-133,NN-244,NN-223,NN-148,NN-206,NN-75,NN-9,NN-193,NN-148,NN-86,NN-138,NN-192,NN-19,NN-114,NN-167,NN-252,
	 NN-159,NN-132,NN-77,NN-115,NN-163,NN-202,NN-154,NN-97,NN-88,NN-151,NN-163,NN-39,NN-252,NN-3,NN-152,NN-118,
	 NN-35,NN-29,NN-199,NN-97,NN-3,NN-4,NN-174,NN-86,NN-191,NN-56,NN-132,NN-0,NN-64,NN-167,NN-14,NN-253,
	 NN-255,NN-82,NN-254,NN-3,NN-111,NN-149,NN-48,NN-241,NN-151,NN-251,NN-192,NN-133,NN-96,NN-214,NN-128,NN-37,
	 NN-169,NN-99,NN-190,NN-3,NN-1,NN-78,NN-56,NN-226,NN-249,NN-162,NN-52,NN-255,NN-187,NN-62,NN-3,NN-68,
	 NN-120,NN-0,NN-144,NN-203,NN-136,NN-17,NN-58,NN-148,NN-101,NN-192,NN-124,NN-99,NN-135,NN-240,NN-60,NN-175,
	 NN-214,NN-37,NN-228,NN-139,NN-56,NN-10,NN-172,NN-114,NN-33,NN-212,NN-248,NN-7
};

//	wb_̃`FbNTvZ
u8 cksum(const u8 *buff)
{
	int i;
	unsigned int chk=0;
	//00A0h00BCh
	for(i=0x00A0;i<=0x00BC;i++)
	{
		chk=chk-buff[i];
	}
	chk=(chk - 0x19)& 0xFF;
	return chk;
}
#define TITLE_LEN 12
#define CODE_LEN 4
int main(int argv,char *argc[])
{
	char filename[256];
	int size,sz,dum;
	su8 title[13]="            ";
	su8 code[5]="    ";
	su8 buff[HEADSIZE];
	u8  sum,sumerr=0;
	int i;

	FILE *fp;


	if(argv<=1)
	{
				PrintHelp();
				exit(EXIT_SUCCESS);
	}
	

	printf("argv=%d\n",argv);

	strcpy(filename, argc[1]);

	fp = fopen(filename, "r+b");
	if(fp==NULL)
	{
		printf("file open err:'%s'\n",filename);
		return -1;
	}
	printf("file open:'%s'\n",filename);

//	fseek(fp, 0, SEEK_END); size = ftell(fp);
	size=fread(buff,1,HEADSIZE,fp);
	if(size<HEADSIZE)
	{
		printf("GBA file too short !! size=%d \n",size);
		return -1;
	}
	fseek(fp, 0, SEEK_SET);

dbgl;

	//	`FbNTvZ
	sum=cksum(buff);
	if(sum != buff[0x00BD])
	{
		sumerr=1;
	//	fclose(fp);
		printf("GBA file head broken. (cheksum error data=%0X sum=%0X) \n",buff[0x00BD],sum);
	//	return -1;
	}

dbgl;

	if(argv>=3)	//^Cg
	{
dbgl;
		for(i=0;i<TITLE_LEN;i++)
		{
			if(argc[2][i]==0)break;
			title[i]=argc[2][i];
		}
dbgl;
	}
	else
	{
		int len,w=0;
dbgl;
		len=strlen(argc[1]);
		for(i=len-1;i>=0;i--)
		{
			if(argc[1][i]=='\\')
			{
				w=i+1;
				break;
			}
		}
dbgl;
		for(i=0;i<TITLE_LEN;i++)
		{
			if(argc[1][w+i]==0)break;
			if(argc[1][w+i]=='.')break;
			title[i]=argc[1][w+i];
		}
dbgl;
	}
dbgl;
	if(argv>=4)	//CODE
	{
dbgl;
		for(i=0;i<CODE_LEN;i++)
		{
//			printf("i=%d ",i);
			if(argc[3][i]==0)break;
			code[i]=argc[3][i] & 0xDF;
		}
dbgl;
	}
	else
	{
dbgl;
		for(i=0;i<CODE_LEN;i++)
		{
			code[i]=title[i] & 0xDF;
		}
dbgl;
	}

dbgl;
	for(i=0;i<nlogo_len;i++)
	{
		nlogo[i]=NN-nlogo[i];
	}

	memcpy(&buff[0x0004],nlogo,nlogo_len);
	memcpy(&buff[0x00A0],title,TITLE_LEN);
	memcpy(&buff[0x00AC],code,CODE_LEN);
	buff[0x00BD]=cksum(buff);
dbgl;

	if(sumerr==0)
	{
	fwrite(buff,1,HEADSIZE,fp);
	}
dbgl;

	title[TITLE_LEN]=0;
	code[CODE_LEN]=0;
	printf("TITLE='%s' CODE='%s'\n",title,code);
	
      if (fseek(fp, 0, SEEK_END) != 0) 
        {
          fprintf(stderr, "fseek error\n");
          return -1;
        }
      
      if ((size = ftell(fp)) < 0) 
        {
          
          fprintf(stderr, "ftell error\n");
          return -1;
        }
    
    dum=size%0x10000;
    if(dum!=0)
    {
    //	size=size + 0x10000 - dum;
    	dum=0x10000 - dum;
    	for(i=0;i<dum;i++)
    	{
    		fputc(0XFF,fp);
    	}
		printf("size fix $%04X -> $%04X \n",size,size+dum);

//    	size=size + 0x10000 - dum;
//    	fseek(fp, dum, SEEK_SET);
    }


	fclose(fp);
	printf("done\n");
	return 0;
}



void PrintHelp(void)
{
	fprintf( stderr,
	TITLE "\n"
		"Usage: GBAHEAD [GBA file] [TITLE] [CODE] \n"

	);
}
